{
char *out, *err;
int r;
- int proc_ok, dev_ok, sys_ok;
+ int proc_ok, dev_ok, dev_pts_ok, sys_ok;
/* We need a root filesystem mounted to do this. */
NEED_ROOT (NULL);
* We deliberately allow these commands to fail silently, BUT
* if a mount fails, don't unmount the corresponding mount.
*/
- r = command (NULL, NULL, "mount", "--rbind", "/dev", "/sysroot/dev", NULL);
+ r = command (NULL, NULL, "mount", "--bind", "/dev", "/sysroot/dev", NULL);
dev_ok = r != -1;
- r = command (NULL, NULL, "mount", "--rbind", "/proc", "/sysroot/proc", NULL);
+ r = command (NULL, NULL, "mount", "--bind", "/dev/pts", "/sysroot/dev/pts", NULL);
+ dev_pts_ok = r != -1;
+ r = command (NULL, NULL, "mount", "--bind", "/proc", "/sysroot/proc", NULL);
proc_ok = r != -1;
- r = command (NULL, NULL, "mount", "--rbind", "/sys", "/sysroot/sys", NULL);
+ r = command (NULL, NULL, "mount", "--bind", "/sys", "/sysroot/sys", NULL);
sys_ok = r != -1;
CHROOT_IN;
if (sys_ok) command (NULL, NULL, "umount", "/sysroot/sys", NULL);
if (proc_ok) command (NULL, NULL, "umount", "/sysroot/proc", NULL);
+ if (dev_pts_ok) command (NULL, NULL, "umount", "/sysroot/dev/pts", NULL);
if (dev_ok) command (NULL, NULL, "umount", "/sysroot/dev", NULL);
if (r == -1) {
--- /dev/null
+#!/bin/sh -
+# libguestfs
+# Copyright (C) 2009 Red Hat Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+
+# Regression test for:
+# https://bugzilla.redhat.com/show_bug.cgi?id=503169#c13
+#
+# The unmount-all command will give this error:
+# libguestfs: error: umount: /sysroot/dev: umount: /sysroot/dev: device is busy.
+# (In some cases useful info about processes that use
+# the device is found by lsof(8) or fuser(1))
+
+set -e
+
+rm -f test1.img
+dd if=/dev/zero of=test1.img bs=1024k count=10
+
+export LIBGUESTFS_PATH=../appliance
+
+../fish/guestfish -a test1.img <<EOF
+run
+sfdisk /dev/sda 0 0 0 ,
+mkfs ext2 /dev/sda1
+mount /dev/sda1 /
+mkdir /dev
+-command /ignore-this-error
+unmount-all
+EOF
+
+rm test1.img